
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/times.h>
#include <time.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/Xlib.h> 
#include <X11/Xutil.h>
#include <X11/cursorfont.h>

#if defined(VM_SCR) || defined(USE_VM)
#include <sys/mman.h>
#endif


#include "QLtypes.h"
#include "QL68000.h"
#include "unix.h"

#include "uqlx_cfg.h"

#define vbase qlscreen.qm_lo
#define STATIC static

extern int screen_drawable;

extern int colors[8];
extern char *xi_buf;
extern int pbytes;
extern jg_display_mode;

#if defined(VM_SCR) || defined(USE_VM)
extern char *scrModTable;
extern int sct_size; 
#endif

extern int shmflag;
extern Display *display;
extern Window imagewin;
extern GC gc;
extern XImage *image;
extern int planes,plane2;

void draw_chunk(void);
void (*QL2Pixmap) (w32 , char *, w32 ,w32 );


#define min(a,b)  (a<b ? a : b)

screen_specs qlscreen={131072,131072+32768,32768,128,256,512};


void QClip(int *x1, int *y1, int *w,int *h)
{
  *x1= *x1>=0 ? *x1 : 0;
  *y1= *y1>=0 ? *y1 : 0;
  
  *x1= *x1<=qlscreen.xres-1 ? *x1 : qlscreen.xres-1;
  *y1= *y1<=qlscreen.yres-1 ? *y1 : qlscreen.yres-1;

  if (*x1+*w>qlscreen.xres) *w=qlscreen.xres-*x1;
  if (*y1+*h>qlscreen.yres) *h=qlscreen.yres-*y1;
}


/* convert image from bufer, from, to */
void QL2Pixmap8 (w32 st, char *data, w32 from,w32 to)
{
  int r1, r2;
  int i, k;
  char *r;
  long dist;


  r=st+(Ptr)theROM;
   
  
  data+=(from-qlscreen.qm_lo)*pbytes*4/*plane2*/;
  r+=from-qlscreen.qm_lo;


  /*if (to>131072+32768)printf("to %d !!!\n",to); */
  dist=(to-from)/2;

if (jg_display_mode == 8)
{ 
  for (k=0; k<dist; k++)
    {
      r1=*(uw8*)r++;
      r2=*(uw8*)r++;
      
      for(i=0; i<4; i++)
	{
          /* That's a double pixel ! */ 
	  *(data+7-(i*2)) = colors[((r1&2)<<1)+((r2&3))+((r1&1)<<3)];
	  *(data+7-(i*2+1)) = colors[((r1&2)<<1)+((r2&3))+((r1&1)<<3)];
	  r1=r1>>2; r2=r2>>2;
	}
      data+=8;
    }
}
else
{
  for (k=0; k<dist; k++)
    {
      r1=*(uw8*)r++;
      r2=*(uw8*)r++;
      
      for(i=0; i<8; i++)
	{
	  /* *(data+7-i) = colors[((r1&1)<<2)+((r2&1)<<1)]; */   *(data+7-i) = colors[((r1&1)<<2)+((r2&1)<<1)+((r1&1)&(r2&1))]; 
	  r1=r1>>1; r2=r2>>1;
	}
      data+=8;
    }
}
  /*if (r-(long)theROM>131072+32*1024 || data-8-xi_buf>512*256)printf(".... to %d, buflen %d\n",r-(long)theROM,data-8-xi_buf);*/
}

void QL2Pixmap16 (w32 st, char *data, w32 from,w32 to)
{
  int r1, r2;
  int i, k;
  char *r;
  long dist;


  r=st+(Ptr)theROM;
   
  
  data+=(from-qlscreen.qm_lo)*pbytes*4/*plane2*/;
  r+=from-qlscreen.qm_lo;


  /* printf("height %d, width %d\n",height,width); */
  dist=(to-from)/2;
if (jg_display_mode == 8)
{  
  for (k=0; k<dist; k++)
    {
      r1=*(uw8*)r++;
      r2=*(uw8*)r++;
	
      for(i=0; i<4; i++)
	{
	  unsigned short x;
	  /* x = colors[((r1&2)<<1)+((r2&3))];*/
	  x = colors[((r1&2)<<1)+((r2&3))+((r1&1)<<3)];
	  *(ushort*)((ushort*)data+7-(i*2)) = x /*(x  << 8) + (x >> 8)*/;
	  *(ushort*)((ushort*)data+7-(i*2+1)) = x /*(x  << 8) + (x >> 8)*/;
	  
	  r1=r1>>2; r2=r2>>2;
	}
      data+=16;
    }
}
else
{
  for (k=0; k<dist; k++)
    {
      r1=*(uw8*)r++;
      r2=*(uw8*)r++;
	
      for(i=0; i<8; i++)
	{
	  unsigned short x;
	  /*x = colors[((r1&1)<<2)+((r2&1)<<1)]; */   x = colors[((r1&1)<<2)+((r2&1)<<1)+((r1&1)&(r2&1))]; 
	  *(ushort*)((ushort*)data+7-i) = x /*(x  << 8) + (x >> 8)*/;
	  
	  r1=r1>>1; r2=r2>>1;
	}
      data+=16;
    }
}
}

void QL2Pixmap24 (w32 st, char *data, w32 from,w32 to)
{
  int r1, r2;
  int i, k;
  char *r;
  long dist;


  r=st+(Ptr)theROM;
   
  
  data+=(from-qlscreen.qm_lo)*pbytes*4;
  r+=from-qlscreen.qm_lo;


  /* printf("height %d, width %d\n",height,width); */
  /*if (to>131072+32768)printf("to %d !!!\n",to); */

  dist=(to-from)/2;

if (jg_display_mode == 8)
{
  for (k=0; k<dist; k++)
    {
      r1=*(uw8*)r++;
      r2=*(uw8*)r++;
      
      for(i=0; i<4; i++)
	{
	  unsigned long x;
	  /*x = colors[((r1&2)<<1)+((r2&3))];*/
	  x = colors[((r1&2)<<1)+((r2&3))+((r1&1)<<3)];
	  *((unsigned int*)data+7-(2*i)) = x /*(x  << 8) + (x >> 8)*/;
	  *((unsigned int*)data+7-(2*i+1)) = x /*(x  << 8) + (x >> 8)*/;
	  r1=r1>>2; r2=r2>>2;
	}
      data+=pbytes*8;
    }
}
else
{
  for (k=0; k<dist; k++)
    {
      r1=*(uw8*)r++;
      r2=*(uw8*)r++;
      
      for(i=0; i<8; i++)
	{
	  unsigned long x;
	  /*x = colors[((r1&1)<<2)+((r2&1)<<1)]; */ x = colors[((r1&1)<<2)+((r2&1)<<1)+((r1&1)&(r2&1))]; 
	  *((unsigned int*)data+7-i) = x /*(x  << 8) + (x >> 8)*/;
	  r1=r1>>1; r2=r2>>1;
	}
      data+=pbytes*8;
    }
}
  /*if (r-(long)theROM>131072+32768 || data-8*pbytes-xi_buf>512*256*4)printf(".... to %d, buflen %d from %d\n",r-(long)theROM,data-8*pbytes-xi_buf,from);*/
}

void QL2Pixmap32 (w32 st, char *data, w32 from,w32 to)
{
  int r1, r2;
  int i, k;
  char *r;
  long dist;


  r=st+(Ptr)theROM;
   
  
  data+=(from-qlscreen.qm_lo)*pbytes*4/*plane2*/;
  r+=from-qlscreen.qm_lo;


  /* printf("height %d, width %d\n",height,width); */
  dist=(to-from)/2;


if (jg_display_mode == 8)
{
    for (k=0; k<dist; k++)
      {
	r1=*(uw8*)r++;
	r2=*(uw8*)r++;
	
	for(i=0; i<4; i++)
	  {
	    unsigned long x;
	    /*x = colors[((r1&2)<<1)+((r2&3))];*/
	    x = colors[((r1&2)<<1)+((r2&3))+((r1&1)<<3)];
	    *(unsigned int*)((unsigned int*)data+7-(2*i)) = (x  << 8) + (x >> 8);
	    *(unsigned int*)((unsigned int*)data+7-(2*i+1)) = (x  << 8) + (x >> 8);
	    
            r1=r1>>2; r2=r2>>2;
	  }
	data+=pbytes*8;
      }
}
else
{
    for (k=0; k<dist; k++)
      {
	r1=*(uw8*)r++;
	r2=*(uw8*)r++;
	
	for(i=0; i<8; i++)
	  {
	    unsigned long x;
	    /*x = colors[((r1&1)<<2)+((r2&1)<<1)]; */   x = colors[((r1&1)<<2)+((r2&1)<<1)+((r1&1)&(r2&1))]; 
	    *(unsigned int*)((unsigned int*)data+7-i) = (x  << 8) + (x >> 8);
	    
            r1=r1>>1; r2=r2>>1;
	  }
	data+=pbytes*8;
      }
}
}




extern int rx1,rx2,ry1,ry2,finishflag;  

void inline conv_chunk(w32 from, w32 to)
{
  int x1,x2,y1,y2,width,height;
  
  
  if (from<qlscreen.qm_lo) from=qlscreen.qm_lo;
  if (to>qlscreen.qm_hi) to=qlscreen.qm_hi;

  x1=(from&(qlscreen.linel-1))*4;
  x2=min((to&(qlscreen.linel-1))*4+4,qlscreen.xres-1);
  y1=(from-qlscreen.qm_lo)/qlscreen.linel;
  y2=(to-qlscreen.qm_lo)/qlscreen.linel;

#if 0
  printf("conv_chunk %d %d \n",from,to);
#endif

  if(y1!=y2) { x1=0; x2=qlscreen.xres-1; }
 
  if (x1>rx1) x1=rx1;
  if (x2<rx2) x2=rx2;
  if (y1>ry1) y1=ry1;
  if (y2<ry2) y2=ry2;
  

  
  width=min((x2-x1+4),qlscreen.xres);
  height=min((y2-y1+1),qlscreen.yres);
  
  (*QL2Pixmap)(vbase,xi_buf, from, to);

#if defined(VM_SCR) || defined(USE_VM)
  displayFrom=displayTo=0;
#endif

/*
#if 1
  if (!finishflag)
#else
  if (height*width<300 && height<12 && width<40 && !finishflag)
#endif
*/
    {
      rx1=x1; rx2=x2;
      ry1=y1; ry2=y2;
      return;
    }    
}


void do_scrconv(/*w32 from, w32 to*/)
{
#if defined(VM_SCR) || defined(USE_VM)
  int i,ii,xfrom,xto; 
  long *ascr,*oscr;

  char *nxpage;
  
  xfrom=xto=i=0;

#if 0
  printf("***** entering scrconv : %d %d %d %d %d %d %d %d \n",scrModTable[0],scrModTable[1],
	 scrModTable[2],scrModTable[3],scrModTable[4],scrModTable[5],scrModTable[6],
	 scrModTable[7]);
#endif

next_page:
  while (!scrModTable[i] && i<sct_size)
    {
      /*scrModTable[i]=0;*/
      i++;
    }
  if (i>=sct_size) goto x_exit;
  
  ascr=(char*)theROM+qlscreen.qm_lo+PAGEX(i);
  /*printf("%d,\t%d\n",oscr,PAGEX(i));*/
  
  oscr=oldscr+PAGEX(i);
  nxpage=oldscr+PAGEX(i+1)+2*sizeof(*oscr);
  
  /*scrModTable[i]=0;*/



next_change:
#if 0
  printf("scrconv page %d\trealpage %d\toffset %d\n",i,(((int)((char*)oscr-oldscr))/pagesize),(char*)oscr-oldscr-pagesize*(((int)((char*)oscr-oldscr))/pagesize));
#endif

  while( *ascr++ == *oscr++ && 
	 ((char *)oscr <= nxpage) /*(char*)oldscr+32768+sizeof(*oscr))*/  );

#if 0
  printf("scrconv search stopped: page %d\trealpage %d\toffset %d\n",i,(((int)((char*)oscr-oldscr))/pagesize),(char*)oscr-oldscr-pagesize*(((int)((char*)oscr-oldscr))/pagesize));
#endif

  if ((char *)oscr > nxpage /*&& *(ascr-1)==*(oscr-1)*/ ) 
    {
      scrModTable[i]=0;
      goto next_page;
    }

  /*printf("i1 %d\t\t",i);*/
  
  i= PAGEI((char*)(oscr-2)-oldscr);
  nxpage=oldscr+PAGEX(i+1)+2*sizeof(*oscr);

  /*printf("i2 %d\n",i);*/

  ascr--;
  oscr--;
  
  xfrom=(w32)((char*)ascr-(char*)theROM);
  ii=i;
  

  while( *ascr++!=*oscr++ && 
	 (char *)oscr<oldscr+(qlscreen.qm_hi-qlscreen.qm_lo)+2*sizeof(long) )  
    *(oscr-1)=*(ascr-1);    /* actualise cmp buffer */

#if 0
  printf("scrconv end of diff area: page %d\trealpage %d\toffset %d\n",i,(((int)((char*)oscr-oldscr))/pagesize),(char*)oscr-oldscr-pagesize*(((int)((char*)oscr-oldscr))/pagesize));
#endif

  /*if ((char *)oscr >= oldscr+(i+1)*pagesize+2*sizeof(*oscr)) /*goto next_page;*/

  i=(int)PAGEI((char*)oscr-oldscr);
  /*printf("page: %d, state %d\n",i,scrModTable[i]);*/
  
  xto=(w32)((char*)ascr-(char*)theROM);
  
  if(xfrom<qlscreen.qm_hi)
    conv_chunk(xfrom,xto);
  
  if (i<sct_size){
    if (i==ii)
      goto next_change;
    else goto next_page;
  }


x_exit:
  for(i=0;i<sct_size;i++) scrModTable[i]=0;
  if (mprotect((Ptr)theROM+qlscreen.qm_lo,qlscreen.qm_hi-qlscreen.qm_lo,PROT_READ)<0)
    perror("can't change MM permission");

  
#else   /* ! not VM_SCR */

  conv_chunk(displayFrom,displayTo+4);
  
#endif  
  
  if (finishflag)
  draw_chunk();

}

void scrconv()
{
  if (screen_drawable)
    do_scrconv();
}


void draw_chunk()
{ 
  int width,height;
  
#if 0
  printf("draw_chunk %d %d %d %d\n",rx1,ry1,rx2,ry2);
#endif

  if (rx1>rx2 || ry1>ry2) return;

  width=rx2-rx1+1; height=ry2-ry1+1;
  
  QClip(&rx1,&ry1,&width,&height);

  if (! screen_drawable) return;
  
#ifdef SH_MEM
  if (shmflag) 
    XShmPutImage(display,imagewin,gc,image,
		 rx1,ry1,            /* src x,y */
		 rx1,ry1,             /* dest x,y */
		 width, height,     /* width,heigth */
		 False);
  else 
#endif
    XPutImage(display, imagewin, gc, image,
		 rx1, ry1,        
		 rx1, ry1,        
		 width, height ); 

  rx1=511;rx2=0;ry1=255;ry2=0;
  /*displayFrom=displayTo=0;*/

  XFlush (display);
  /*process_events();*/

}


void redraw_screen( int x1,int y1,int width,int height)
{
  int x2,y2;

#if 0
 printf("redraw screen: %d,%d %d,%d\n",x1,y1,x1+width,y1+height); 
#endif
  x2=x1+width;
  y2=y1+height;

  if (x1>rx1) x1=rx1;
  if (x2<rx2) x2=rx2;
  if (y1>ry1) y1=ry1;
  if (y2<ry2) y2=ry2; 

#if 0
 printf(".... combined to: %d,%d %d,%d\n",x1,y1,x2,y2); 
#endif

 QClip(&x1,&y1,&width,&height);

#if 0
 printf(".... cliped to: %d,%d %d,%d\n",x1,y1,width,height); 
#endif

 
#ifdef SH_MEM
  if (shmflag)
    XShmPutImage(display,imagewin,gc,image,
		 x1,y1,            /* src x,y */
		 x1,y1,             /* dest x,y */
		 width,height,     /* width,heigth */
		 False);
  else
#endif
    XPutImage(display, imagewin, gc, image,
	      x1, y1,        
	      x1, y1,        
	      width, height ); 
  
  rx1=qlscreen.xres;rx2=0;ry1=qlscreen.yres;ry2=0; /* nothing to do*/

  /*XFlush (display); */ /* done in x.c:process_events*/

}


