/*              Copyright (c) 1995 Daniele Terdina
*/

#include <signal.h>
#include "QLtypes.h"
#include "QL68000.h"

#include "vm.h"

void debug(char*);
void debug2(char*,long);

void    (**table)(void);

#ifdef DEBUG
int trace_rts=0;
#endif

#define INLINE

/* when USE_VM is used, declare alternative memory access routines */
/* to use in case of VM exception */

#ifdef USE_VM
#include "memaccess.h"
#endif

INLINE w32     GetEA_m2(short) REGP1;
INLINE w32     GetEA_m5(short) REGP1;
INLINE w32     GetEA_m6(short) REGP1;
INLINE w32     GetEA_m7(short) REGP1;
INLINE w32     GetEA_mBad(short) REGP1;
w32
(*GetEA[8])(short) REGP1 ={GetEA_mBad,GetEA_mBad,GetEA_m2,GetEA_mBad,GetEA_mBad,
		    GetEA_m5,GetEA_m6,GetEA_m7};

INLINE w8      GetFromEA_b_m0(void);
INLINE w8      GetFromEA_b_mBad(void);
INLINE w8      GetFromEA_b_m2(void);
INLINE w8      GetFromEA_b_m3(void);
INLINE w8      GetFromEA_b_m4(void);
INLINE w8      GetFromEA_b_m5(void);
INLINE w8      GetFromEA_b_m6(void); 
INLINE w8      GetFromEA_b_m7(void);
w8
(*GetFromEA_b[8])(void)={GetFromEA_b_m0,GetFromEA_b_mBad,GetFromEA_b_m2,
			 GetFromEA_b_m3,GetFromEA_b_m4,GetFromEA_b_m5,GetFromEA_b_m6,GetFromEA_b_m7};


INLINE w16     GetFromEA_w_m0(void);
INLINE w16     GetFromEA_w_m1(void);
INLINE w16     GetFromEA_w_m2(void);
INLINE w16     GetFromEA_w_m3(void);
INLINE w16     GetFromEA_w_m4(void);
INLINE w16     GetFromEA_w_m5(void);
INLINE w16     GetFromEA_w_m6(void);
INLINE w16     GetFromEA_w_m7(void);
w16
(*GetFromEA_w[8])(void)={GetFromEA_w_m0,GetFromEA_w_m1,GetFromEA_w_m2,
			 GetFromEA_w_m3,GetFromEA_w_m4,GetFromEA_w_m5,GetFromEA_w_m6,GetFromEA_w_m7};


INLINE w32     GetFromEA_l_m0(void);
INLINE w32     GetFromEA_l_m1(void);
INLINE w32     GetFromEA_l_m2(void);
INLINE w32     GetFromEA_l_m3(void);
INLINE w32     GetFromEA_l_m4(void);
INLINE w32     GetFromEA_l_m5(void);
INLINE w32     GetFromEA_l_m6(void);
INLINE w32     GetFromEA_l_m7(void);
w32
(*GetFromEA_l[8])(void)={GetFromEA_l_m0,GetFromEA_l_m1,GetFromEA_l_m2,
			 GetFromEA_l_m3,GetFromEA_l_m4,GetFromEA_l_m5,GetFromEA_l_m6,GetFromEA_l_m7};


INLINE void PutToEA_b_m0(short,w8) REGP2;
INLINE void PutToEA_b_mBad(short,w8) REGP2;
INLINE void PutToEA_b_m2(short,w8) REGP2;
INLINE void PutToEA_b_m3(short,w8) REGP2;
INLINE void PutToEA_b_m4(short,w8) REGP2;
INLINE void PutToEA_b_m5(short,w8) REGP2;
INLINE void PutToEA_b_m6(short,w8) REGP2;
INLINE void PutToEA_b_m7(short,w8) REGP2;
void
(*PutToEA_b[8])(short,w8) REGP2 ={PutToEA_b_m0,PutToEA_b_mBad,PutToEA_b_m2,PutToEA_b_m3,PutToEA_b_m4,PutToEA_b_m5,PutToEA_b_m6,PutToEA_b_m7};



INLINE void PutToEA_w_m0(short,w16) REGP2;
INLINE void PutToEA_w_m1(short,w16) REGP2;
INLINE void PutToEA_w_m2(short,w16) REGP2;
INLINE void PutToEA_w_m3(short,w16) REGP2;
INLINE void PutToEA_w_m4(short,w16) REGP2;
INLINE void PutToEA_w_m5(short,w16) REGP2;
INLINE void PutToEA_w_m6(short,w16) REGP2;
INLINE void PutToEA_w_m7(short,w16) REGP2;
void
(*PutToEA_w[8])(short,w16) REGP2 ={PutToEA_w_m0,PutToEA_w_m1,PutToEA_w_m2,
			    PutToEA_w_m3,PutToEA_w_m4,PutToEA_w_m5,PutToEA_w_m6,PutToEA_w_m7};



INLINE void PutToEA_l_m0(short,w32) REGP2;
INLINE void PutToEA_l_m1(short,w32) REGP2;
INLINE void PutToEA_l_m2(short,w32) REGP2;
INLINE void PutToEA_l_m3(short,w32) REGP2;
INLINE void PutToEA_l_m4(short,w32) REGP2;
INLINE void PutToEA_l_m5(short,w32) REGP2;
INLINE void PutToEA_l_m6(short,w32) REGP2;
INLINE void PutToEA_l_m7(short,w32) REGP2;
void
(*PutToEA_l[8])(short,w32) REGP2 ={PutToEA_l_m0,PutToEA_l_m1,PutToEA_l_m2,
			    PutToEA_l_m3,PutToEA_l_m4,PutToEA_l_m5,PutToEA_l_m6,PutToEA_l_m7};






static inline void FlushDisplay() 
{
  /* printf("update screen: from %d TO %d\n",displayFrom,displayTo); */
  if (!script)
  scrconv(displayFrom,displayTo);
}

#if defined(USE_VM) || defined (VM_SCR)
#define FlushDisplay()
#endif




#ifdef DEBUG
#define TRR  {trace_rts=20;}
#else 
#define TRR
#endif



w32 GetEA_m2(short r)
{   
  return  aReg[r];
}

w32 GetEA_m5(short r)
{     
  return aReg[r]+(w16)RW(pc++);
}

w32 GetEA_m6(short r)
{
  w16 displ;

  displ=(w16)RW(pc++);
  if((displ&2048)!=0)
    return *(((w32*)((Ptr)reg+((displ>>10)&60)))) + aReg[r] + (w32)((w8)displ);
  /*        register access */
  return (w32) (*((w16*)((Ptr)reg+RWO+((displ>>10)&60)))) + aReg[r] + (w32)((w8)displ);
}

w32 GetEA_m7(short r)
{   
  w16 displ;
  switch(r) {
  case 0:displ=(w16)RW(pc++);
    return displ;
  case 1:pc+=2;
    return  RL((w32*)(pc-2));/* *((w32*)(pc-2));*/
  case 2:displ=(w16)RW(pc++);
    return (Ptr)pc-(Ptr)theROM-2+displ;
  case 3:
    displ=(w16)RW(pc++);
    if((displ&2048)!=0) return reg[(displ>>12) & 15]+
			  (Ptr)pc-(Ptr)theROM-2+(w32)((w8)displ);
    return (w32)((w16)(reg[(displ>>12) & 15]))+
      (Ptr)pc-(Ptr)theROM-2+(w32)((w8)displ);
  }
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
  return 0;
}

w32 GetEA_m7_3(void)
{     
  w16 displ;

  displ=(w16)RW(pc++);
  if((displ&2048)!=0) return reg[(displ>>12) & 15]
			+(Ptr)pc-(Ptr)theROM-2+(w32)((w8)displ);
  return (w32)((w16)(reg[(displ>>12) & 15]))+
    (Ptr)pc-(Ptr)theROM-2+(w32)((w8)displ);
}


w32 GetEA_mBad(short r)
{    
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
  return 0;
}

w8 GetFromEA_b_m0(void)
{ 
  return (w8)(reg[code&7]);
}

w8 GetFromEA_b_mBad(void)
{    
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
  return 0;
}

w8 GetFromEA_b_m2(void)
{    
  return ReadByte(aReg[code&7]);
}

w8 GetFromEA_b_m3(void)
{  
  register w8 b;
  register short r;
  r=code&7;
  b=ReadByte(aReg[r]);
  aReg[r]++;
  if(r==7) aReg[r]++;
  return b;
}

/* added as special case for cmpm */
w8 GetFromEA_rb_m3(short r)
{  
  register w8 b;
  uw32 addr;
  
  addr=aReg[r]++;
  if(r==7) aReg[r]++;
  b=ReadByte(addr);

  return b;
}
w16 GetFromEA_rw_m3(short r)
{  
  uw32 addr;

  addr=aReg[r];
  aReg[r]+=2; 
  
  return ReadWord(addr);
}

w32 GetFromEA_rl_m3(short r)
{  
  uw32 addr;
  
  addr=aReg[r];
  aReg[r]+=4;

  return ReadLong(addr);
}
/****/

w8 GetFromEA_b_m4(void)
{    
  register short r;
      
  r=code&7;
  if(r==7) aReg[r]--;
  return ReadByte(--aReg[r]);
}

w8 GetFromEA_b_m5(void)
{   
  return ReadByte(aReg[code&7]+(w16)RW(pc++));
}

w8 GetFromEA_b_m6(void)
{    
  return ReadByte(GetEA_m6(code&7));
}

w8 GetFromEA_b_m7(void)
{   
  register short r;
  register w32 addr;

  r=code&7;
  switch(r){
  case 0:
    return ReadByte((w32)((w16)RW(pc++)));
  case 1:
    /*addr=*((w32*)pc);*/
    addr=RL((w32*)pc);
    pc+=2;
    return ReadByte(addr);
  case 2:
    addr=(w32)pc-(w32)theROM+(w16)RW(pc);
    pc++;
    return ReadByte(addr);
  case 3:
    return ReadByte(GetEA_m7_3());
  case 4:
    pc++;
    return RB((w8*)pc-1);
  }
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
  return 0;
}

w16 GetFromEA_w_m0(void)
{    
  return (w16)(reg[code&7]);
}

w16 GetFromEA_w_m1(void)
{    
  return (w16)(aReg[code&7]);
}

w16 GetFromEA_w_m2(void)
{    
  return ReadWord(aReg[code&7]);
}

w16 GetFromEA_w_m3(void)
{   
  register w16 t;
  register short r;
  r=code&7;
  t=ReadWord(aReg[r]);
  aReg[r]+=2;
  return t;
}

w16 GetFromEA_w_m4(void)
{    
  return ReadWord(aReg[code&7]-=2);
}

w16 GetFromEA_w_m5(void)
{    
  return ReadWord(aReg[code&7]+(w16)RW(pc++));
}

w16 GetFromEA_w_m6()
{   
  w16 displ;
  displ=(w16)RW(pc++);
  return ReadWord(((displ&2048)!=0)? 
		  (*((w32*)((Ptr)reg+((displ>>10)&60)))+
		     aReg[code&7]+(w32)((w8)displ)) :
		  (w32)*(((w16*)((Ptr)reg+RWO+((displ>>10)&60))))+
		     aReg[code&7]+(w32)((w8)displ));
}

w16 GetFromEA_w_m7(void)
{      
  register short r;
  register w32 addr;

  r=code&7;
  switch(r){
  case 0:
    return ReadWord((w32)((w16)RW(pc++)));
  case 1:
    addr=RL((w32*)pc);
    pc+=2;
    return ReadWord(addr);
  case 2:
    addr=(w32)pc-(w32)theROM+(w16)RW(pc);
    pc++;
    return ReadWord(addr);
  case 3:
    return ReadWord(GetEA_m7_3());
  case 4:
    return (w16)RW(pc++);
  }
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
  return 0;
}

w32 GetFromEA_l_m0(void)
{    
  return reg[code&7];
}

w32 GetFromEA_l_m1(void)
{     
  return aReg[code&7];
}

w32 GetFromEA_l_m2(void)
{     
  return ReadLong(aReg[code&7]);
}

w32 GetFromEA_l_m3(void)
{     
  register w32 t;
  register short r;
  r=code&7;
  t=ReadLong(aReg[r]);
  aReg[r]+=4;
  return t;
}

w32 GetFromEA_l_m4(void)
{     
  return ReadLong(aReg[code&7]-=4);
}

w32 GetFromEA_l_m5(void)
{     
  return ReadLong(aReg[code&7]+(w16)RW(pc++));
}

w32 GetFromEA_l_m6(void)
{    
  return ReadLong(GetEA_m6(code&7));
}

w32 GetFromEA_l_m7(void)
{    
  register short r;
  register w32 addr;

  r=code&7;
  switch(r){
  case 0:
    return ReadLong((w32)((w16)RW(pc++)));
  case 1:
    addr=RL((w32*) pc);/* *((w32*)pc); */
    pc+=2;
    return ReadLong(addr);
  case 2:
    addr=(w32)pc-(w32)theROM+(w16)RW(pc);
    pc++;
    return ReadLong(addr);
  case 3:
    return ReadLong(GetEA_m7_3());
  case 4:
    pc+=2;
    return RL((w32*)(pc-2));/* *((w32*)(pc-2));*/
  }
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
  return 0;
}

void PutToEA_b_m0(short r,w8 d)
{   
  *( (w8*)( (Ptr)(&(reg[r])) + RBO ) )=d;
}

void PutToEA_b_mBad(short r,w8 d)
{    
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
}

void PutToEA_b_m2(short r,w8 d)
{   
  WriteByte(aReg[r],d);
}

void PutToEA_b_m3(short r,w8 d)
{     
  WriteByte(aReg[r],d);
  aReg[r]++;
  if(r==7) aReg[r]++;
}

void PutToEA_b_m4(short r,w8 d)
{   
  if(r==7) aReg[r]--;
  WriteByte(--aReg[r],d);
}

void PutToEA_b_m5(short r,w8 d)
{    
  WriteByte(aReg[r]+(w16)RW(pc++),d);
}

void PutToEA_b_m6(short r,w8 d)
{   
  WriteByte(GetEA_m6(r),d);
}

void PutToEA_b_m7(short r,w8 d)
{     
  WriteByte(GetEA_m7(r),d);
}

void PutToEA_w_m0(short r,w16 d)
{
  *( (w16*)( (Ptr)(&(reg[r])) + RWO ) )=d; 
}

void PutToEA_w_m1(short r,w16 d)
{   
  *( (w16*)( (Ptr)(&(aReg[r])) + RWO ) )=d; 
}

void PutToEA_w_m2(short r,w16 d)
{     
  WriteWord(aReg[r],d);
}

void PutToEA_w_m3(short r,w16 d)
{     
  WriteWord(aReg[r],d);
  aReg[r]+=2;
}

void PutToEA_w_m4(short r,w16 d)
{    
  WriteWord(aReg[r]-=2,d);
}

void PutToEA_w_m5(short r,w16 d)
{     
  WriteWord(aReg[r]+(w16)RW(pc++),d);
}

void PutToEA_w_m6(short r,w16 d)
{     
  WriteWord(GetEA_m6(r),d);
}

void PutToEA_w_m7(short r,w16 d)
{    
  WriteWord(GetEA_m7(r),d);
}

void PutToEA_l_m0(short r,w32 d)
{     
  reg[r]=d;
}

void PutToEA_l_m1(short r,w32 d)
{    
  aReg[r]=d;
}

void PutToEA_l_m2(short r,w32 d)
{    
  WriteLong(aReg[r],d);
}

void PutToEA_l_m3(short r,w32 d)
{    
  WriteLong(aReg[r],d);
  aReg[r]+=4;
} 

void PutToEA_l_m4(short r,w32 d)
{    
  WriteLong(aReg[r]-=4,d);
}

void PutToEA_l_m5(short r,w32 d)
{   
  WriteLong(aReg[r]+(w16)RW(pc++),d);
}

void PutToEA_l_m6(short r,w32 d)
{   
  WriteLong(GetEA_m6(r),d);
}

void PutToEA_l_m7(short r,w32 d)
{   
  WriteLong(GetEA_m7(r),d);
}


